SystemOrganization addCategory: #Seafox!

WAFileLibrary subclass: #SFLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seafox'!

!SFLibrary methodsFor: 'uploaded' stamp: 'NickAger 7/30/2010 17:39'!
browserCss
	^ '#seafoxButton {
  font-weight: bold;
  list-style-image: url("chrome://seafox/content/seasideicon.png");
}'! !

!SFLibrary methodsFor: 'uploaded' stamp: 'NickAger 8/1/2010 16:29'!
browserJs
	^ 'let Seafox = {
  onCommand: function(event) {
    let nodeTypes = {
        ELEMENT_NODE: 1,
        ATTRIBUTE_NODE: 2,
        TEXT_NODE: 3,
        CDATA_SECTION_NODE: 4,
        ENTITY_REFERENCE_NODE: 5,
        ENTITY_NODE: 6,
        PROCESSING_INSTRUCTION_NODE: 7,
        COMMENT_NODE: 8,
        DOCUMENT_NODE: 9,
        DOCUMENT_TYPE_NODE: 10,
        DOCUMENT_FRAGMENT_NODE: 11,
        NOTATION_NODE: 12
    }
    
    let nodeTypesLookup = {
        ELEMENT_NODE: ''ELEMENT_NODE'',
        ATTRIBUTE_NODE: ''ATTRIBUTE_NODE'',
        TEXT_NODE: ''TEXT_NODE'',
        CDATA_SECTION_NODE: ''CDATA_SECTION_NODE'',
        ENTITY_REFERENCE_NODE: ''ENTITY_REFERENCE_NODE'',
        ENTITY_NODE: ''ENTITY_NODE'',
        PROCESSING_INSTRUCTION_NODE: ''PROCESSING_INSTRUCTION_NODE'',
        COMMENT_NODE: ''COMMENT_NODE'',
        DOCUMENT_NODE: ''DOCUMENT_NODE'',
        DOCUMENT_TYPE_NODE: ''DOCUMENT_TYPE_NODE'',
        DOCUMENT_FRAGMENT_NODE: ''DOCUMENT_FRAGMENT_NODE'',
        NOTATION_NODE: ''NOTATION_NODE''
    }
    
    // the recursive DOM walker
    function walkTheDOM(node, obj) {
        obj.push(node);
        node = node.firstChild; 
        while (node) {
            walkTheDOM(node, obj);
            node = node.nextSibling;
        }
        obj.pop();
    }

    function getIndentString(indent) {
        let indentString = '''';
        for (let i=0; i < indent-1; ++i) {
            indentString += ''    '';
        }
        return indentString;
    }
    
    function smalltalkFromAttributeValue(attributeValue) {
        if(parseInt(attributeValue).toString() === attributeValue) {
            return attributeValue;
        }
        if (attributeValue.toLowerCase() === ''true'' || attributeValue.toLowerCase() === ''false'') {
            return attributeValue.toLowerCase();
        }
        return "''" + attributeValue + "''";
    }
    
    function createBrush(spec, aNode) {
        let indent = 0;
        let node = null;
        let hasAttributes = false;
        let hasChildNodes = false;
        let hasOnlySingleTextChild = false;
        let hasSiblings = false;
        
        // method can be called with one the spec parameter ie createBrush(spec)
        if (aNode !!== undefined) {
            node = aNode;
            hasChildNodes = node.hasChildNodes();
            hasOnlySingleTextChild = (node.childNodes.length === 1 && node.firstChild.nodeType === nodeTypes.TEXT_NODE);
            hasSiblings = (node.nextSibling !!== null);
            hasAttributes = node.hasAttributes();
        }
        
        function smalltalkSelector() {
            return spec.selector;
        }
        
        function isUnarySelector(aSelector) {
            if (aSelector.charAt(aSelector.length-1) === '':'') {
                return false;
            }
            return true;
        }
        
        function smalltalkAttributeSelector (htmlAttribute) {
            return spec.attributeMapping[htmlAttribute];
        }
        
        function smalltalkDeprecatedAttributeSelector (htmlAttribute) {
            return spec.attributeMappingDeprecated[htmlAttribute];
        }
        
        function opening(anIndent, aSmalltalkRenderer) {
            let output = '''';
            indent = anIndent
            
            output += getIndentString(indent) + aSmalltalkRenderer + '' '' + smalltalkSelector();
            
            for (let i = 0; i < node.attributes.length; ++i) {
                let attributeName = node.attributes[i].nodeName.toLowerCase();
                let attributeValue = node.attributes[i].nodeValue;
                let attributeSelector = smalltalkAttributeSelector(attributeName);
                
                if (attributeSelector === undefined) {
                    attributeSelector = smalltalkDeprecatedAttributeSelector(attributeName);
                    if (attributeSelector !!== undefined) {
                        output += '' "deprecated attribute->" ''
                    }
                }
                
                if (attributeSelector === undefined) {
                    output += '' "unmapped attribute->" '' + "attributeAt: ''" + attributeName + "'' put: ''" + attributeValue + "''";
                } else {
                    if (isUnarySelector(attributeSelector)) {
                        output += '' '' + attributeSelector;
                    } else {
                        output += '' '' + attributeSelector + '' '' + smalltalkFromAttributeValue(attributeValue);
                    }
                }
                if (i !!== node.attributes.length -1) {
                    output += '';'';
                 }
            }

            return output + selectorLineEnd();
        }
        
        function selectorLineEnd () {
            let lineEnd = '''';

            if (hasAttributes && hasOnlySingleTextChild) {
                lineEnd = ''; with: '';                    
            }
            else if (hasAttributes && hasChildNodes && !!hasOnlySingleTextChild) {
                lineEnd = ''; with: [\n'';                    
            } else if (!!hasAttributes && hasChildNodes && !!hasOnlySingleTextChild) {
                lineEnd = '':[\n'';
            } else if (!!hasAttributes && hasOnlySingleTextChild) {
                lineEnd = '':'';
            }
            
            return lineEnd;
        }
        
        function closing() {
            let output = '''';
            if (hasChildNodes && !!hasOnlySingleTextChild) {
                output += getIndentString(indent) + '']'';
            }
            if (hasSiblings) {
                output += ''.'';
            }
            output += ''\n'';
            
            return output;
        }
        
        function cloneForNode(aNode) {
            return createBrush(spec, aNode);
        }
        
        return {
            opening: opening,
            closing: closing,

            cloneForNode: cloneForNode,
        }
    }
    
    function createHeadingBrush(spec, level) {
        spec.selector = ''heading'';
        return {
            cloneForNode: function(aNode) {
                aNode.setAttribute(''level'', level);
                return createBrush(spec, aNode)
            }
        }
    }
    
    function createHeadHTMLElementBrush() {
        return {
            opening: function() {return ''''},
            closing: function() {return ''''},

            cloneForNode: function() {return this}
        }
    }
    
    function createLinkHTMLElementBrush (aNode) {
        let node = aNode;
        
        function opening (indent, aSmalltalkRenderer) {
            let isStylesheetLink = false;
            let isIconLink = false;
            let isJavascriptLink = false
            let url = ''''
            let output = getIndentString(indent);
            
            for (let i = 0; i < node.attributes.length; ++i) {
                let attributeName = node.attributes[i].nodeName.toLowerCase();
                let attributeValue = node.attributes[i].nodeValue;
                if (attributeName === ''href'') {
                    url = attributeValue;
                }
                if (attributeValue === ''shortcut icon'') {
                    isIconLink = true;
                }
                if (attributeValue === ''stylesheet'' || attributeValue === ''text/css'') {
                    isStylesheetLink = true;
                }
                if (attributeValue === ''text/javascript'') {
                    isJavascript == true;
                }
            }
            if (isJavascriptLink) {
                output += aSmalltalkRenderer + " javascript url: ''" + url + "''"; 
            }
            if (isIconLink) {
                output += aSmalltalkRenderer + " link beShortcutIcon; url: ''" + url + "''"; 
            }
            if (isStylesheetLink) {
                output += aSmalltalkRenderer + " stylesheet url: ''" + url + "''"; 
            }
            return output;
        }        
        return {
            opening: opening,
            closing: function() {return ''.\n''},

            cloneForNode: function(aNode) {return createLinkHTMLElementBrush(aNode)}
        }    
    }

    function createBodyHTMLElementBrush() {
         return {
            opening: function() {return ''''},
            closing: function() {return ''''},

            cloneForNode: function() {return this}
        }
    }
    
    function headBrushCreator() {
        let brushes = {}, i;
        for (i in headMapping) {
            brushes[i]=createBrush(headMapping[i]);
        }
        brushes["head"]=createHeadHTMLElementBrush();
        brushes["link"]=createLinkHTMLElementBrush();
        
        function brush(node) {
            let attributeMapping = headMapping[node.nodeName.toLowerCase()]
            let brush = brushes[node.nodeName.toLowerCase()];
            if (brush === undefined) {
                brush = createGenericBrush(node);
            } else {
                brush = brush.cloneForNode(node);
            }
            return brush;
        }
    
        return {
            brush:brush
        }
    
    }


    function bodyBrushCreator() {
        let brushes = {}, i;
        for (i in bodyMapping) {
            brushes[i]=createBrush(bodyMapping[i]);
        }
        brushes["body"]=createBodyHTMLElementBrush();

        for (let i = 1; i <= 6; ++i) {
            brushes["h" + i]=createHeadingBrush(bodyMapping["h" + i], i);
        }
        
        function brush(node) {
            let brush = brushes[node.nodeName.toLowerCase()];
            if (brush === undefined) {
                brush = createGenericBrush(node);
            } else {
                brush = brush.cloneForNode(node);
            }
            return brush;
        }
    
        return {
            brush:brush
        }
    
    }
    
    

    function createGenericBrush(node) {
        let hasAttributes = node.hasAttributes();
        let hasSiblings = (node.nextSibling !!== null);
        let hasChildNodes = node.hasChildNodes();
        let hasOnlySingleTextChild = (node.childNodes.length === 1 && node.firstChild.nodeType === nodeTypes.TEXT_NODE);
        let indent = 0;
        
        function opening(anIndent, aSmalltalkRenderer) {
            indent = anIndent;
            
            let output = getIndentString(indent) + ''"Unrecognised element \'''' + node.nodeName.toLowerCase() + ''\''"\n'';
            output += getIndentString(indent) + "(" + aSmalltalkRenderer + " tag: ''" + node.nodeName.toLowerCase() + "'')";
            for (let i = 0; i < node.attributes.length; ++i) {
                output += " attributeAt: ''" + node.attributes[i].nodeName.toLowerCase() + "'' put:''" + node.attributes[i].nodeValue+"''";
                if (i !!== node.attributes.length -1) {
                    output += '';'';
                }
            }
            if (!!hasChildNodes)
                return output;
            
            if (hasAttributes) {
                output += '';'';                    
            } 
            output += '' with:'';
            
            if (!!hasOnlySingleTextChild) {
                output += ''[\n'';
            }
            
            return output;
        }
        
        function closing() {
            let output = '''';
            if (!!hasOnlySingleTextChild && hasChildNodes) {
                output += getIndentString(indent) + '']'';
            }
            
            if (hasSiblings) {
                output += ''.'';
            }
            output += ''\n'';
            
            return output;
        }
    
        return {
            opening: opening,
            closing: closing
        }
    }


    function createTextBrush(node) {
        let isOnlyChildNode = node.parentNode.childNodes.length === 1;
        let hasSiblings = (node.nextSibling !!== null);
        let nothingToRender = false;
        
        function opening(indent, aSmalltalkRenderer) {
            let output = '''';
            let text = node.nodeValue;
            let matches = text.match(/\/\*<!!\[CDATA\[\*\/(.*)\/\*\]\]>\*\//);
            if (matches !!== undefined && matches !!== null) {
                text = matches[1];
            }
            
            text = text.replace(/''/g, "''''");

            if (text.trim().length === 0 && !!isOnlyChildNode) {
                nothingToRender = true;
                return '''';
            }
            
            if (!!isOnlyChildNode) {
                output += getIndentString(indent) + aSmalltalkRenderer + '' text:'';
            }
            
            output += "''" + text + "''";
            
            return output;
        }
        
        function closing() {
            let output = '''';
            
            if (nothingToRender) {
                return '''';
            }
            
            if (!!isOnlyChildNode && hasSiblings) {
                output += ''.'';
            }

            if (!!isOnlyChildNode) {
                output += ''\n'';
            }
            
            return output;
        }
        
        return {
            opening: opening,
            closing: closing
        }
    }
 
    function createUnprocessedNodeBrush(node) {
        return {
            opening: function(indent, aSmalltalkRenderer) {
                return getIndentString(indent) + ''"*** UnprocessedNode. nodeType:\'''' + nodeTypesLookup[node.nodeType] + ''\'', nodeName:\'''' + node.nodeName + ''\''"\n'';
            },
            closing: function () {
                return '''';
            }
        }
    }


    
    /* other possible renders: an HTML renderer, a Smalltalk renderer (creates an .st file)*/
    function createStringRenderer (aSmalltalkMethodSignature, aSmalltalkRenderer) {
        let stringRenderer = aSmalltalkMethodSignature +''\n'';
        let stack = [];
        
        function result() {
            return stringRenderer;
        }
        
        function push(aBrush) {
            stack.push(aBrush);
            stringRenderer += aBrush.opening(stack.length, aSmalltalkRenderer);
        }
        
        function pop() {
            let brush = stack.pop();
            stringRenderer += brush.closing();
        }
        
        return {
            push: push,
            pop: pop,
            result: result
        }
    
    }

    

    function createDomWalker(aRenderer, aBrushCreator) {
        let renderer = aRenderer;
        let brushCreator = aBrushCreator;
  
        function push (node) {
            let brush = null;
            
            switch (node.nodeType) {
                case nodeTypes.ELEMENT_NODE:
                    brush = brushCreator.brush(node);
                    break;
                    
                case nodeTypes.TEXT_NODE:
                    brush = createTextBrush(node);
                    break; 
                    
                case nodeTypes.ATTRIBUTE_NODE:
                case nodeTypes.CDATA_SECTION_NODE:
                case nodeTypes.ENTITY_REFERENCE_NODE:
                case nodeTypes.ENTITY_NODE:
                case nodeTypes.PROCESSING_INSTRUCTION_NODE:
                case nodeTypes.COMMENT_NODE:
                case nodeTypes.DOCUMENT_NODE:
                case nodeTypes.DOCUMENT_TYPE_NODE:
                case nodeTypes.DOCUMENT_FRAGMENT_NODE:
                case nodeTypes.NOTATION_NODE:
                    brush = createUnprocessedNodeBrush(node);
                    break;
            
            }
            renderer.push(brush);
        }
            
        function pop() {
            renderer.pop();
        }

        return {
            push: push,
            pop: pop
        }   
    }
    
    function getTitle() {
        let title = '''';
        let titleNode = head.getElementsByTagName("title")[0];
        if (titleNode !!== undefined) {
            title = head.getElementsByTagName("title")[0].innerHTML;  // tried nodeValue rather than innerHTML but the result was null. why?
        }
        return title;
    }

    
    let updateRootStringRenderer = createStringRenderer(''updateRoot: anHTMLRoot'', ''anHTMLRoot'');
    let domWalker = createDomWalker(updateRootStringRenderer, headBrushCreator());
    let head = gBrowser.contentDocument.getElementsByTagName("head")[0];
    walkTheDOM(head, domWalker);

    let renderContentOnStringRenderer = createStringRenderer(''renderContentOn: html'', ''html'');
    let domWalker = createDomWalker(renderContentOnStringRenderer, bodyBrushCreator());
    let body = gBrowser.contentDocument.getElementsByTagName("body")[0];
    walkTheDOM(body, domWalker);
    
    let newTab = gBrowser.addTab();
    let newTabBrowser = gBrowser.getBrowserForTab(newTab);

    function loader() {
        newTabBrowser.contentDocument.getElementsByTagName("head")[0].innerHTML = "<title>Seaside translation of: ''" + getTitle() + "''</title>";
        newTabBrowser.contentDocument.body.innerHTML = "<code><pre>" + updateRootStringRenderer.result() + ''\n\n'' + renderContentOnStringRenderer.result() + "</pre></code>";
        newTabBrowser.removeEventListener("load", loader, true);
    }

    gBrowser.selectedTab = newTab;
    newTabBrowser.addEventListener("load", loader, true);
    }
}'! !

!SFLibrary methodsFor: 'uploaded' stamp: 'NickAger 8/1/2010 18:29'!
browserXul
	^ '<?xml-stylesheet href="chrome://seafox/content/browser.css" type="text/css"?>
<overlay xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul">
<script type="application/javascript"
          src="chrome://seafox/content/browser.js" />
<script type="application/javascript"
          src="chrome://seafox/content/elementAttributeMapping.js" />
  <statusbar id="status-bar">
		<statusbarpanel id="seafoxIcon" label="seafox" onclick="Seafox.onCommand(event)">
			<image tooltiptext="Translate Html to Seaside render methods"  src="chrome://seafox/content/seasideicon.png"/>
		</statusbarpanel>
  </statusbar>
</overlay>'! !

!SFLibrary methodsFor: 'uploaded' stamp: 'NickAger 8/1/2010 17:16'!
chromeManifest
	^ 'content  seafox         chrome/content/
locale   seafox  en-US  chrome/locale/en-US/

overlay  chrome://browser/content/browser.xul chrome://seafox/content/browser.xul'! !

!SFLibrary methodsFor: 'style-seaside' stamp: 'NickAger 8/1/2010 21:11'!
infoCss
	^ '* {
	line-height: 1.5;
	font-family: "Helvetica Neue", Helvetica, Verdana, Arial, sans-serif;
}

html, body {
	color: #2a2a2a;
	font-size: 14px;
	margin-top: 0px;
}

a {
color:#008AFF;
text-decoration:none;
}

.ui-widget-content {
	background-color: white;
}

.container {
	position: absolute;
	left: 50%;
	margin-left: -450px;
	
	margin-top: 0px;
	width: 1000px;
}

h1 {
	margin-top: 30px;
	margin-bottom: 5px;
	clear: left;
}

.opening {
	margin-bottom:12px;
}

.topheading {
	display: inline;
}

.heading {
	font-weight: bold;
}

.headingLine {
	border-bottom: 1px solid #CCCCCC;
	clear: left;
	margin-bottom: 4px;
}

.left, .htmlTag {
	width: 150px;
	float: left;
	m; Cascade expected ->argin-top: 2px;
	margin-bottom: 2px;
}

.middle, .factorySelector{
	width: 150px;
	float: left;
	margin-top: 2px;
	margin-bottom: 2px;
}

.right, .allAttributes {
	width: 700px;
	float: right;
	margin-top: 2px;
	margin-bottom: 2px;
}

.downloadButton {
	float: right;
	margin: 10px;
}

.body {

}

.attributes {
}

.attributePair {
	background-color:#f4f4f4;
	margin-left: 4px;
	padding: 2px;
	border 1px solid #444444;
	margin-top: 2px;
	margin-bottom: 2px;
}

.attributeSelector {
color: burlyWood;
}

.popAttributeContainer{
	width: 630px;
}

.htmlPopUpAttribute {
	width: 120px;
	float: left;
}

.selectorPopUpAttribute {
	width: 180px;
	float: left;
}

.popUpAttributeFirst {
	clear: left;
}

.popUpAttributeBorder {
	border-right: 1px solid #CCCCCC;
	margin-right: 20px;
}


.deprecatedAttributes {
	font-size: 80%;
}'! !

!SFLibrary methodsFor: 'uploaded' stamp: 'NickAger 8/1/2010 23:10'!
installRdf
	^ '<?xml version="1.0" encoding="UTF-8"?>
<RDF xmlns="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
     xmlns:em="http://www.mozilla.org/2004/em-rdf#">
  <Description about="urn:mozilla:install-manifest">
    <em:id>seafox@nick.ager</em:id>
    <em:name>Seafox</em:name>
	<em:creator>Nick Ager</em:creator>
	<em:iconURL>chrome://seafox/content/seasideicon.png</em:iconURL>
    <em:version>0.1</em:version>
    <em:description>Translates Html into Seaside render methods</em:description>
    <em:homepageURL>http://www.squeaksource.com/Seafox.html</em:homepageURL>
    <em:targetApplication> <!!-- Firefox -->
      <Description>
        <em:id>{ec8030f7-c20a-464f-9b0e-13a3a9e97384}</em:id>
        <em:minVersion>3.0</em:minVersion>
        <em:maxVersion>4.0b3pre</em:maxVersion>
      </Description>
    </em:targetApplication>
  </Description>
</RDF>'! !

!SFLibrary methodsFor: 'uploaded' stamp: 'NickAger 8/1/2010 17:08'!
seasideiconPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 10 79 105 67 67 80 80 104 111 116 111 115 104 111 112 32 73 67 67 32 112 114 111 102 105 108 101 0 0 120 218 157 83 103 84 83 233 22 61 247 222 244 66 75 136 128 148 75 111 82 21 8 32 82 66 139 128 20 145 38 42 33 9 16 74 136 33 161 217 21 81 193 17 69 69 4 27 200 160 136 3 142 142 128 140 21 81 44 12 138 10 216 7 228 33 162 142 131 163 136 138 202 251 225 123 163 107 214 188 247 230 205 254 181 215 62 231 172 243 157 179 207 7 192 8 12 150 72 51 81 53 128 12 169 66 30 17 224 131 199 196 198 225 228 46 64 129 10 36 112 0 16 8 179 100 33 115 253 35 1 0 248 126 60 60 43 34 192 7 190 0 1 120 211 11 8 0 192 77 155 192 48 28 135 255 15 234 66 153 92 1 128 132 1 192 116 145 56 75 8 128 20 0 64 122 142 66 166 0 64 70 1 128 157 152 38 83 0 160 4 0 96 203 99 98 227 0 80 45 0 96 39 127 230 211 0 128 157 248 153 123 1 0 91 148 33 21 1 160 145 0 32 19 101 136 68 0 104 59 0 172 207 86 138 69 0 88 48 0 20 102 75 196 57 0 216 45 0 48 73 87 102 72 0 176 183 0 192 206 16 11 178 0 8 12 0 48 81 136 133 41 0 4 123 0 96 200 35 35 120 0 132 153 0 20 70 242 87 60 241 43 174 16 231 42 0 0 120 153 178 60 185 36 57 69 129 91 8 45 113 7 87 87 46 30 40 206 73 23 43 20 54 97 2 97 154 64 46 194 121 153 25 50 129 52 15 224 243 204 0 0 160 145 21 17 224 131 243 253 120 206 14 174 206 206 54 142 182 14 95 45 234 191 6 255 34 98 98 227 254 229 207 171 112 64 0 0 225 116 126 209 254 44 47 179 26 128 59 6 128 109 254 162 37 238 4 104 94 11 160 117 247 139 102 178 15 64 181 0 160 233 218 87 243 112 248 126 60 60 69 161 144 185 217 217 229 228 228 216 74 196 66 91 97 202 87 125 254 103 194 95 192 87 253 108 249 126 60 252 247 245 224 190 226 36 129 50 93 129 71 4 248 224 194 204 244 76 165 28 207 146 9 132 98 220 230 143 71 252 183 11 255 252 29 211 34 196 73 98 185 88 42 20 227 81 18 113 142 68 154 140 243 50 165 34 137 66 146 41 197 37 210 255 100 226 223 44 251 3 62 223 53 0 176 106 62 1 123 145 45 168 93 99 3 246 75 39 16 88 116 192 226 247 0 0 242 187 111 193 212 40 8 3 128 104 131 225 207 119 255 239 63 253 71 160 37 0 128 102 73 146 113 0 0 94 68 36 46 84 202 179 63 199 8 0 0 68 160 129 42 176 65 27 244 193 24 44 192 6 28 193 5 220 193 11 252 96 54 132 66 36 196 194 66 16 66 10 100 128 28 114 96 41 172 130 66 40 134 205 176 29 42 96 47 212 64 29 52 192 81 104 134 147 112 14 46 194 85 184 14 61 112 15 250 97 8 158 193 40 188 129 9 4 65 200 8 19 97 33 218 136 1 98 138 88 35 142 8 23 153 133 248 33 193 72 4 18 139 36 32 201 136 20 81 34 75 145 53 72 49 82 138 84 32 85 72 29 242 61 114 2 57 135 92 70 186 145 59 200 0 50 130 252 134 188 71 49 148 129 178 81 61 212 12 181 67 185 168 55 26 132 70 162 11 208 100 116 49 154 143 22 160 155 208 114 180 26 61 140 54 161 231 208 171 104 15 218 143 62 67 199 48 192 232 24 7 51 196 108 48 46 198 195 66 177 56 44 9 147 99 203 177 34 172 12 171 198 26 176 86 172 3 187 137 245 99 207 177 119 4 18 129 69 192 9 54 4 119 66 32 97 30 65 72 88 76 88 78 216 72 168 32 28 36 52 17 218 9 55 9 3 132 81 194 39 34 147 168 75 180 38 186 17 249 196 24 98 50 49 135 88 72 44 35 214 18 143 19 47 16 123 136 67 196 55 36 18 137 67 50 39 185 144 2 73 177 164 84 210 18 210 70 210 110 82 35 233 44 169 155 52 72 26 35 147 201 218 100 107 178 7 57 148 44 32 43 200 133 228 157 228 195 228 51 228 27 228 33 242 91 10 157 98 64 113 164 248 83 226 40 82 202 106 74 25 229 16 229 52 229 6 101 152 50 65 85 163 154 82 221 168 161 84 17 53 143 90 66 173 161 182 82 175 81 135 168 19 52 117 154 57 205 131 22 73 75 165 173 162 149 211 26 104 23 104 247 105 175 232 116 186 17 221 149 30 78 151 208 87 210 203 233 71 232 151 232 3 244 119 12 13 134 21 131 199 136 103 40 25 155 24 7 24 103 25 119 24 175 152 76 166 25 211 139 25 199 84 48 55 49 235 152 231 153 15 153 111 85 88 42 182 42 124 21 145 202 10 149 74 149 38 149 27 42 47 84 169 170 166 170 222 170 11 85 243 85 203 84 143 169 94 83 125 174 70 85 51 83 227 169 9 212 150 171 85 170 157 80 235 83 27 83 103 169 59 168 135 170 103 168 111 84 63 164 126 89 253 137 6 89 195 76 195 79 67 164 81 160 177 95 227 188 198 32 11 99 25 179 120 44 33 107 13 171 134 117 129 53 196 38 177 205 217 124 118 42 187 152 253 29 187 139 61 170 169 161 57 67 51 74 51 87 179 82 243 148 102 63 7 227 152 113 248 156 116 78 9 231 40 167 151 243 126 138 222 20 239 41 226 41 27 166 52 76 185 49 101 92 107 170 150 151 150 88 171 72 171 81 171 71 235 189 54 174 237 167 157 166 189 69 187 89 251 129 14 65 199 74 39 92 39 71 103 143 206 5 157 231 83 217 83 221 167 10 167 22 77 61 58 245 174 46 170 107 165 27 161 187 68 119 191 110 167 238 152 158 190 94 128 158 76 111 167 222 121 189 231 250 28 125 47 253 84 253 109 250 167 245 71 12 88 6 179 12 36 6 219 12 206 24 60 197 53 113 111 60 29 47 199 219 241 81 67 93 195 64 67 165 97 149 97 151 225 132 145 185 209 60 163 213 70 141 70 15 140 105 198 92 227 36 227 109 198 109 198 163 38 6 38 33 38 75 77 234 77 238 154 82 77 185 166 41 166 59 76 59 76 199 205 204 205 162 205 214 153 53 155 61 49 215 50 231 155 231 155 215 155 223 183 96 90 120 90 44 182 168 182 184 101 73 178 228 90 166 89 238 182 188 110 133 90 57 89 165 88 85 90 93 179 70 173 157 173 37 214 187 173 187 167 17 167 185 78 147 78 171 158 214 103 195 176 241 182 201 182 169 183 25 176 229 216 6 219 174 182 109 182 125 97 103 98 23 103 183 197 174 195 238 147 189 147 125 186 125 141 253 61 7 13 135 217 14 171 29 90 29 126 115 180 114 20 58 86 58 222 154 206 156 238 63 125 197 244 150 233 47 103 88 207 16 207 216 51 227 182 19 203 41 196 105 157 83 155 211 71 103 23 103 185 115 131 243 136 139 137 75 130 203 46 151 62 46 155 27 198 221 200 189 228 74 116 245 113 93 225 122 210 245 157 155 179 155 194 237 168 219 175 238 54 238 105 238 135 220 159 204 52 159 41 158 89 51 115 208 195 200 67 224 81 229 209 63 11 159 149 48 107 223 172 126 79 67 79 129 103 181 231 35 47 99 47 145 87 173 215 176 183 165 119 170 247 97 239 23 62 246 62 114 159 227 62 227 60 55 222 50 222 89 95 204 55 192 183 200 183 203 79 195 111 158 95 133 223 67 127 35 255 100 255 122 255 209 0 167 128 37 1 103 3 137 129 65 129 91 2 251 248 122 124 33 191 142 63 58 219 101 246 178 217 237 65 140 160 185 65 21 65 143 130 173 130 229 193 173 33 104 200 236 144 173 33 247 231 152 206 145 206 105 14 133 80 126 232 214 208 7 97 230 97 139 195 126 12 39 133 135 133 87 134 63 142 112 136 88 26 209 49 151 53 119 209 220 67 115 223 68 250 68 150 68 222 155 103 49 79 57 175 45 74 53 42 62 170 46 106 60 218 55 186 52 186 63 198 46 102 89 204 213 88 157 88 73 108 75 28 57 46 42 174 54 110 108 190 223 252 237 243 135 226 157 226 11 227 123 23 152 47 200 93 112 121 161 206 194 244 133 167 22 169 46 18 44 58 150 64 76 136 78 56 148 240 65 16 42 168 22 140 37 242 19 119 37 142 10 121 194 29 194 103 34 47 209 54 209 136 216 67 92 42 30 78 242 72 42 77 122 146 236 145 188 53 121 36 197 51 165 44 229 185 132 39 169 144 188 76 13 76 221 155 58 158 22 154 118 32 109 50 61 58 189 49 131 146 145 144 113 66 170 33 77 147 182 103 234 103 230 102 118 203 172 101 133 178 254 197 110 139 183 47 30 149 7 201 107 179 144 172 5 89 45 10 182 66 166 232 84 90 40 215 42 7 178 103 101 87 102 191 205 137 202 57 150 171 158 43 205 237 204 179 202 219 144 55 156 239 159 255 237 18 194 18 225 146 182 165 134 75 87 45 29 88 230 189 172 106 57 178 60 113 121 219 10 227 21 5 43 134 86 6 172 60 184 138 182 42 109 213 79 171 237 87 151 174 126 189 38 122 77 107 129 94 193 202 130 193 181 1 107 235 11 85 10 229 133 125 235 220 215 237 93 79 88 47 89 223 181 97 250 134 157 27 62 21 137 138 174 20 219 23 151 21 127 216 40 220 120 229 27 135 111 202 191 153 220 148 180 169 171 196 185 100 207 102 210 102 233 230 222 45 158 91 14 150 170 151 230 151 14 110 13 217 218 180 13 223 86 180 237 245 246 69 219 47 151 205 40 219 187 131 182 67 185 163 191 60 184 188 101 167 201 206 205 59 63 84 164 84 244 84 250 84 54 238 210 221 181 97 215 248 110 209 238 27 123 188 246 52 236 213 219 91 188 247 253 62 201 190 219 85 1 85 77 213 102 213 101 251 73 251 179 247 63 174 137 170 233 248 150 251 109 93 173 78 109 113 237 199 3 210 3 253 7 35 14 182 215 185 212 213 29 210 61 84 82 143 214 43 235 71 14 199 31 190 254 157 239 119 45 13 54 13 85 141 156 198 226 35 112 68 121 228 233 247 9 223 247 30 13 58 218 118 140 123 172 225 7 211 31 118 29 103 29 47 106 66 154 242 154 70 155 83 154 251 91 98 91 186 79 204 62 209 214 234 222 122 252 71 219 31 15 156 52 60 89 121 74 243 84 201 105 218 233 130 211 147 103 242 207 140 157 149 157 125 126 46 249 220 96 219 162 182 123 231 99 206 223 106 15 111 239 186 16 116 225 210 69 255 139 231 59 188 59 206 92 242 184 116 242 178 219 229 19 87 184 87 154 175 58 95 109 234 116 234 60 254 147 211 79 199 187 156 187 154 174 185 92 107 185 238 122 189 181 123 102 247 233 27 158 55 206 221 244 189 121 241 22 255 214 213 158 57 61 221 189 243 122 111 247 197 247 245 223 22 221 126 114 39 253 206 203 187 217 119 39 238 173 188 79 188 95 244 64 237 65 217 67 221 135 213 63 91 254 220 216 239 220 127 106 192 119 160 243 209 220 71 247 6 133 131 207 254 145 245 143 15 67 5 143 153 143 203 134 13 134 235 158 56 62 57 57 226 63 114 253 233 252 167 67 207 100 207 38 158 23 254 162 254 203 174 23 22 47 126 248 213 235 215 206 209 152 209 161 151 242 151 147 191 109 124 165 253 234 192 235 25 175 219 198 194 198 30 190 201 120 51 49 94 244 86 251 237 193 119 220 119 29 239 163 223 15 79 228 124 32 127 40 255 104 249 177 245 83 208 167 251 147 25 147 147 255 4 3 152 243 252 99 51 45 219 0 0 0 4 103 65 77 65 0 0 177 142 124 251 81 147 0 0 0 32 99 72 82 77 0 0 122 37 0 0 128 131 0 0 249 255 0 0 128 233 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 111 146 95 197 70 0 0 1 197 73 68 65 84 120 218 164 211 191 75 212 113 28 199 241 199 247 206 95 233 149 121 233 21 218 16 185 36 4 9 69 65 34 20 88 73 17 216 24 98 67 147 77 109 13 45 77 97 127 65 100 131 244 3 26 108 107 115 105 144 90 66 208 202 50 19 209 130 74 5 243 192 212 59 175 227 211 160 23 21 119 25 244 94 62 240 126 243 121 190 222 239 55 239 87 20 66 240 95 81 12 48 114 86 87 184 40 140 157 114 109 171 191 177 98 133 186 106 29 106 104 73 185 49 112 68 227 223 32 101 37 179 9 42 146 170 79 103 13 26 209 142 0 15 73 37 104 91 230 57 22 138 2 2 52 98 145 166 163 218 38 210 110 151 175 203 215 209 249 253 189 230 181 69 38 115 250 209 91 20 16 143 217 105 23 230 54 64 7 206 235 149 33 63 78 250 19 185 175 86 231 25 252 109 132 23 221 186 146 149 58 234 235 117 214 54 105 86 131 109 27 93 200 226 37 177 36 177 6 198 167 221 188 196 211 158 2 96 229 138 185 234 42 187 37 177 3 113 204 35 135 81 68 56 70 254 11 175 223 120 124 129 190 130 112 12 86 215 204 201 226 27 50 88 70 122 243 205 108 66 203 88 127 199 200 138 91 133 53 253 4 52 220 211 58 252 193 137 233 105 143 86 166 44 136 97 255 230 8 135 80 69 254 25 21 73 78 150 27 216 236 9 68 33 4 81 20 253 186 195 40 221 99 170 182 67 179 97 28 222 144 249 62 201 210 19 66 142 177 143 250 206 112 189 212 33 133 124 198 178 89 108 39 188 226 115 191 217 244 16 241 4 235 75 236 139 92 189 207 193 146 135 20 86 49 65 40 103 114 212 80 203 184 115 15 104 73 209 189 55 114 57 81 38 21 229 164 74 122 97 161 221 104 246 184 48 211 108 230 110 189 61 127 148 163 130 112 8 161 56 224 109 163 225 217 90 43 119 42 181 110 105 196 18 118 142 163 242 95 156 252 99 0 195 220 166 92 119 172 44 238 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

Object subclass: #SFFirefoxExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seafox'!

!SFFirefoxExtension methodsFor: 'file' stamp: 'NickAger 8/1/2010 18:23'!
createExtension
	| seafoxDirectory chromeDirectory contentDirectory mapper zipArchive |
	"for extension development info see: http://design-challenge.mozillalabs.com/resources/files/extension_bootcamp.pdf"
	
	self flag: #todo. "refactor - create zip file in memory directly from in memory streams - create a collection containing all files/streams then iterate over it - rather than this embassaring ugly code - but no time now"
	
	FileDirectory default assureExistenceOfPath: 'seafox'.
	seafoxDirectory := FileDirectory on: (FileDirectory default fullNameFor: 'seafox').
	
	seafoxDirectory assureExistenceOfPath: 'chrome'.
	chromeDirectory := FileDirectory on: (seafoxDirectory fullNameFor: 'chrome').
	
	chromeDirectory assureExistenceOfPath: 'content'.
	contentDirectory := FileDirectory on: (chromeDirectory fullNameFor: 'content').
	
	contentDirectory forceNewFileNamed: 'browser.js' do: [:stream | stream nextPutAll: SFLibrary default browserJs].
	contentDirectory forceNewFileNamed: 'browser.css' do: [:stream | stream nextPutAll: SFLibrary default browserCss].
	contentDirectory forceNewFileNamed: 'browser.xul' do: [:stream | stream nextPutAll: SFLibrary default browserXul].	
	contentDirectory forceNewFileNamed: 'seasideicon.png' do: [:stream | stream nextPutAll: SFLibrary default seasideiconPng].
	mapper := SFMapper new writeElementAttributeMappingTo: (contentDirectory fullNameFor: 'elementAttributeMapping.js').
	
	seafoxDirectory forceNewFileNamed: 'install.rdf' do: [:stream | stream nextPutAll: SFLibrary default installRdf]. 
	seafoxDirectory forceNewFileNamed: 'chrome.manifest' do: [:stream | stream nextPutAll: SFLibrary default chromeManifest].
	
	zipArchive := ZipArchive new.
	zipArchive addFile: (contentDirectory fullNameFor: 'browser.js') as: 'chrome/content/browser.js'.
	zipArchive addFile: (contentDirectory fullNameFor: 'browser.css') as: 'chrome/content/browser.css'.
	zipArchive addFile: (contentDirectory fullNameFor: 'browser.xul') as: 'chrome/content/browser.xul'.
	zipArchive addFile: (contentDirectory fullNameFor: 'seasideicon.png') as: 'chrome/content/seasideicon.png'.
	zipArchive addFile: (contentDirectory fullNameFor: 'elementAttributeMapping.js') as: 'chrome/content/elementAttributeMapping.js'.
	
	zipArchive addFile: (seafoxDirectory fullNameFor: 'install.rdf') as: 'install.rdf'.
	zipArchive addFile: (seafoxDirectory fullNameFor: 'chrome.manifest') as: 'chrome.manifest'.
	
	FileStream
		forceNewFileNamed: (seafoxDirectory fullNameFor: 'seafox.xpi')
		do: [ :fileStream | 
			zipArchive writeTo: fileStream.
			zipArchive close ].
		
	^ seafoxDirectory fullNameFor: 'seafox.xpi'! !

Object subclass: #SFMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seafox'!

!SFMapper commentStamp: '<historical>' prior: 0!
SFMapper attempts to work out the mapping between html element and their attributes and the Seaside equivalent. It requires ObjectAsMethodWrapper as a method wrapper to intercept calls to the renderer to work out which renderer methods cause html production. !

!SFMapper methodsFor: 'mappings' stamp: 'NickAger 7/28/2010 21:41'!
addHeadingsOn: htmlLookupDictionary withAttributeMapping: attributeMapping
	(attributeMapping at:  #attributeMapping) at: 'level' put: 'level:'.
	(1 to: 6) do: [:level |
		htmlLookupDictionary at: 'h', level asString put: ((Dictionary newFromPairs: (Array with: #selector with: 'heading level:', level asString)) union: attributeMapping)
		]
	
	! !

!SFMapper methodsFor: 'private' stamp: 'NickAger 7/27/2010 16:25'!
createRenderCanvas
	| context |
	context := WARenderContext new.
	context document: (WAHtmlDocument on: (TextStream on: (String new: 100)) codec: GRNullCodec new).
	context actionUrl: WAUrl new.
	
	^ WARenderCanvas context: context! !

!SFMapper methodsFor: 'private' stamp: 'NickAger 7/28/2010 20:11'!
executeSelector: elementSelector on: element
	elementSelector isUnary
		ifTrue: [ element perform: elementSelector ]
		ifFalse: [ 
			"try a string argument, if that fails try an integer argument, if that fails try a boolean, that fails give up"
			self tryExecutingSelector: elementSelector on: element withEachArgument: #('test' 6 true) ]! !

!SFMapper methodsFor: 'private' stamp: 'NickAger 7/29/2010 09:17'!
filteredUnaryAndSingleArgSelectorsFrom: selectors
	| selectorsToIgnore  |
	
	selectorsToIgnore := #(passenger: attributes attributes: storeCallback: with: document: callback: ensureId confirm: onEnter: tag: initializeWithTag: withLineBreaks: before labels: goto: clear).
	^ selectors
		select: [ :selector | (selector isUnary or: [ selector numArgs = 1 ]) and: [ (selectorsToIgnore includes: selector) not ] ]
! !

!SFMapper methodsFor: 'private' stamp: 'NickAger 7/28/2010 16:09'!
getAttributeMappingForElement: element withSelectors: selectors
	| attributeMapping attributeMappingDeprecated |
	
	attributeMapping := self getAttributeMappingForElement: element withSelectors: selectors onlyDeprecatedMethods: false.
	attributeMappingDeprecated := self getAttributeMappingForElement: element withSelectors: selectors onlyDeprecatedMethods: true.

	^ Dictionary newFromPairs: (Array with: #attributeMapping with: attributeMapping with: #attributeMappingDeprecated with: attributeMappingDeprecated)! !

!SFMapper methodsFor: 'private' stamp: 'NickAger 7/29/2010 19:25'!
getAttributeMappingForElement: element withSelectors: selectors onlyDeprecatedMethods: onlyDeprecatedMethods
	| attributeMapping  deprecatedWrapper  |
	
	attributeMapping := Dictionary new.
	self flag:#todo. "store the deprecatedMessage - define two classes SFAttribute SFDeprecatedAttribute have a class side method storeAttribute: isDeprecated simplify the if statement below"
	
	[ 
	| isDeprecatedMethod deprecatedMessage |
	deprecatedWrapper := ObjectAsMethodWrapper installOn: Object selector: #greaseDeprecatedApi:details:.
	deprecatedWrapper preblock: [ :aSel :someArgs :aRec | isDeprecatedMethod := true. deprecatedMessage := someArgs second ].
	(self filteredUnaryAndSingleArgSelectorsFrom: selectors)
		do: [ :elementSelector | 
			| numAttributes wrapper |
			numAttributes := element attributes size.
			1 to: numAttributes do: [ :num | element attributes removeIndex: num ].
			[ 
			isDeprecatedMethod := false.
			self executeSelector: elementSelector on: element.
			((isDeprecatedMethod not and: [onlyDeprecatedMethods not]) or:
				 [ onlyDeprecatedMethods and: [ isDeprecatedMethod ] ] )
				ifTrue: [ 
					numAttributes := element attributes size.
					numAttributes > 0
						ifTrue: [ attributeMapping at: element attributes keys last put: elementSelector asString ] ] ]
				on: Error
				do: [ :ex | 
					self logMessage: 'Error with selector: ' , elementSelector asString , ' for element class: ' , element class asString  forException: ex.] ] ] 
			ensure: [ deprecatedWrapper uninstall ].
	
	"special case for WAAnchorTag and derived classes"	
	(element class == WAAnchorTag or: [ element class inheritsFrom: WAAnchorTag ])
		ifTrue: [ attributeMapping at: 'href' put: 'url:' ].
	
	^ attributeMapping ! !

!SFMapper methodsFor: 'mappings' stamp: 'NickAger 7/29/2010 19:27'!
htmlBodyMappings
	| allUnarySelectors  htmlLookup  classesToIgnore brushMethodWrapper brush |
	classesToIgnore := Array with: WAColorInputTag with: WAPopupAnchorTag with: WAImageMapTag with: WABasicFormTag.
	
	htmlLookup := Dictionary new.
	allUnarySelectors := (WARenderCanvas allSelectorsBelow: WACanvas) select: [:sym | sym isUnary ].
	
	brushMethodWrapper := ObjectAsMethodWrapper installOn: WAHtmlCanvas selector: #brush:.
	brushMethodWrapper preblock: [:aSel :someArgs :aRec |  brush := someArgs first].
	[
	allUnarySelectors do: [:selector |
		[
		WACurrentRequestContext 
			use: (WARequestContext request: nil response: nil)
			during: [
				brush := nil.
				self createRenderCanvas perform: selector.
				"check if performing the selector caused anything to be added to the renderer.
				Also check that the brush class is derived from WATagBrush; we're not interested in WACompound derived brushes,
				rather only those that map directly onto HTML elements"
				((brush notNil and: [brush class inheritsFrom: WATagBrush]) and: [(classesToIgnore includes: brush class) not ]) ifTrue: [
					| attributeMapping htmlElement |
					htmlElement := brush tag. "store the tag string here in case calling the methods on the tag changes the tag string!!"
					attributeMapping := self getAttributeMappingForElement: brush withSelectors: (brush class allSelectorsBelow: WABrush).
					brush class == WAHeadingTag 
						ifTrue: [self addHeadingsOn: htmlLookup withAttributeMapping: attributeMapping]
						ifFalse: [htmlLookup at: htmlElement put: ((Dictionary newFromPairs: (Array with: #selector with: selector asString)) union: attributeMapping) ] ] ] ]
		on: Error do: [:ex | self logMessage: 'selector: ' , selector asString forException: ex ]  ] 
	] ensure: [brushMethodWrapper uninstall].
	
	^ htmlLookup
	! !

!SFMapper methodsFor: 'mappings' stamp: 'NickAger 7/28/2010 16:15'!
htmlHeadMappings
	| allUnarySelectors  htmlLookup |
	
	htmlLookup := Dictionary new.
	allUnarySelectors := WAHtmlRoot localSelectors select: [:sym | sym isUnary].
	
	allUnarySelectors do: [:selector | | htmlRoot |
		htmlRoot := WAHtmlRoot new.
		htmlRoot perform: selector.
		"does performing the selector actually cause anything to be added to the renderer?"
		htmlRoot headElements size > 0 ifTrue: [
			| attributeMapping element  |
			element := htmlRoot headElements first.
			attributeMapping := self getAttributeMappingForElement: element withSelectors: element class localSelectors.
			htmlLookup at: element tag put: ((Dictionary newFromPairs: (Array with: #selector with: selector asString)) union: attributeMapping) ] ].
	
	"special case the title"
	htmlLookup at: 'title' put: (Dictionary newFromPairs: (Array with: #selector with: 'title' with: #attributeMapping with: Dictionary new with: #attributeMappingDeprecated with: Dictionary new)).
	
	^ htmlLookup
	! !

!SFMapper methodsFor: 'error-logging' stamp: 'NickAger 7/29/2010 21:12'!
logMessage: message forException: exception
	"Transcript show: message; cr; show: exception asString; cr; cr"
! !

!SFMapper methodsFor: 'private' stamp: 'NickAger 7/28/2010 15:56'!
tryExecutingSelector: elementSelector on: element withEachArgument: argumentsToTry
	argumentsToTry do: [ :arg |
		[
		element perform: elementSelector with: arg.
		^ self. "no error so return"
		] on: Error do: [:ex | 
			arg == argumentsToTry last ifTrue:[
				"we're tried all the arguments so give-up and rethrow the error"
				ex pass
			] 
		]
	].
! !

!SFMapper methodsFor: 'firefox-js-export' stamp: 'NickAger 7/28/2010 13:36'!
writeElementAttributeMappingTo: file
	"writeElementAttributeMappingTo: '/Users/nickager/Documents/programming/seafox/projects/chrome/content/elementAttributeMapping.js'"
	FileStream
		forceNewFileNamed: file
		do: [ :fileStream | 
			fileStream 
				nextPutAll: 'let headMapping = ';
				nextPutAll: self htmlHeadMappings asJavascript;
				nextPut: $; ;
				nextPutAll: String crlf;
				nextPutAll: 'let bodyMapping = ';
				nextPutAll: self htmlBodyMappings asJavascript;
				nextPut: $; .
			]! !

WAComponent subclass: #SFInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seafox'!

SFInfo class
	instanceVariableNames: 'bodyMapping headMapping mapper xpiContents'!

SFInfo class
	instanceVariableNames: 'bodyMapping headMapping mapper xpiContents'!

!SFInfo class methodsFor: 'caching' stamp: 'NickAger 7/30/2010 11:20'!
bodyMapping
	^ bodyMapping ifNil: [bodyMapping := self mapper htmlBodyMappings associations asSortedCollection ]
! !

!SFInfo class methodsFor: 'caching' stamp: 'NickAger 7/31/2010 17:24'!
extensionFileContents
	^ xpiContents ifNil: [
		| extensionCreator pathToExtension  fileStream |
		
		extensionCreator := SFFirefoxExtension new.
		pathToExtension := extensionCreator createExtension.
		
		fileStream := FileStream fileNamed: pathToExtension.
		fileStream binary.
		xpiContents := fileStream contents.
		fileStream close.
		xpiContents
	]! !

!SFInfo class methodsFor: 'caching' stamp: 'NickAger 7/30/2010 11:21'!
headMapping
	^ headMapping ifNil: [headMapping := self mapper htmlHeadMappings associations asSortedCollection ]
! !

!SFInfo class methodsFor: 'class initialization' stamp: 'NickAger 8/1/2010 19:41'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'seafox'.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQSmoothnessTheme! !

!SFInfo class methodsFor: 'caching' stamp: 'NickAger 7/30/2010 11:24'!
mapper
	"have on class side as we don't want the render to take for ever when it regenerates for map for each new session"
	^ mapper ifNil: [mapper := SFMapper new]! !

!SFInfo class methodsFor: 'caching' stamp: 'NickAger 7/31/2010 16:52'!
reset
	mapper := nil.
	bodyMapping := nil.
	headMapping := nil.
	xpiContents := nil.
	
	! !

!SFInfo methodsFor: 'download' stamp: 'jf 8/1/2010 15:49'!
downloadFirefoxExtension
	self requestContext respond: 
		[ :response  |
		(response
			contentType: (WAMimeType main: 'application' sub: 'x-xpinstall');
			inlineWithFileName: 'seafox.xpi';
			binary;
			stream) nextPutAll: self class extensionFileContents
			]
	
	! !

!SFInfo methodsFor: 'private' stamp: 'NickAger 7/30/2010 09:17'!
renderAttribute: attribute on: html
	html span class: 'attributePair'; with: [
		html span class: 'htmlAttribute'; with: attribute key.
		html space.
		html span class: 'attributeSelector'; with: attribute value.
		html space ]! !

!SFInfo methodsFor: 'private' stamp: 'NickAger 7/30/2010 15:55'!
renderAttributes: attributeMappings on: html title: title
	| sortedAttributes |
	sortedAttributes := attributeMappings associations asSortedCollection.
	1 to: (3 min: sortedAttributes size) do: [ :index |
		| association |
		association := sortedAttributes at: index.
		self renderAttribute: association on: html].
	
	sortedAttributes size > 3 ifTrue: [
		html space.
		html anchor 
			onClick: (self renderAttributesDialogOn: html attributes: sortedAttributes title: title);
			url: 'javascript:void(0)';
			with: '[more... ]' ]
! !

!SFInfo methodsFor: 'private' stamp: 'NickAger 7/30/2010 15:49'!
renderAttributesDialogOn: html attributes: attributes title: title
	^ String streamContents: [:stream |
		| dialogId |
		dialogId := html nextId.
		stream 
			nextPutAll: 'if ($(''#', dialogId greaseString,''').length===0) {';
			nextPutAll: ((html jQuery this) append: [:r |
				r div
					id: dialogId;
					script: (r jQuery new dialog
						autoOpen: true;
						width: 650;
						resizable: false;
						title: title);
					script: ((r jQuery this) load html: [:r2 | self renderAttributesForPopup: attributes on: r2]); 
					with: 'loading...'.
					]) asJavascript;
			nextPutAll: '} else {';
			nextPutAll: ((html jQuery id: dialogId) dialog open) asJavascript;
			nextPutAll: '}' ]! !

!SFInfo methodsFor: 'private' stamp: 'NickAger 7/30/2010 12:09'!
renderAttributesForPopup: sortedAttributes on: html
	| attributeCount |
	attributeCount := 0.
	sortedAttributes do: [ :attribute |
		html div
			class: 'popAttributeContainer';
			with: [ 
				| isNewLine |
				isNewLine := (attributeCount \\ 2) = 0.
				
				html span 
					class: 'htmlAttribute';
					class: 'htmlPopUpAttribute';
					class: 'popUpAttributeFirst' if: isNewLine;
					with: attribute key.
				
				html span
					class: 'attributeSelector';
					class: 'selectorPopUpAttribute';
					class: 'popUpAttributeBorder' if: isNewLine;
					with: attribute value.
			
				attributeCount :=  attributeCount + 1] ]! !

!SFInfo methodsFor: 'rendering' stamp: 'NickAger 8/1/2010 20:55'!
renderContentOn: html
	html div class: 'container'; with: [
		html div: [
			html heading level1; class: 'topheading'; with: 'Html to Seaside renderer mapping'.
			html anchor 
				class: 'downloadButton'; 
				script: (html jQuery this button
					primaryIcon: 'ui-icon-arrowthickstop-1-s');
					callback: [self downloadFirefoxExtension];
				with: 'Firefox extension'].
			
		html div class: 'opening'; with: [
			html heading level2; with: 'Header tags'.
			
		html div class: 'heading'; with: [
			html div class: 'left'; with: 'Html tag'.
			html div class: 'middle'; with: 'renderer method'.
			html div class: 'right'; with: 'attributes' ].
		html div class: 'headingLine'.
		
		self renderTagsAndSelectorsOn: html with: self class headMapping ].

		html div: [
			html break.
			html heading level2; style:'clear:both'; with: 'Body tags'.
		
			html div class: 'heading'; with: [			
				html div class: 'left'; with: 'Html tag'.
				html div class: 'middle'; with: 'renderer method'.
				html div class: 'right'; with:  'attributes' ].
			html div class: 'headingLine'.
			
			self renderTagsAndSelectorsOn: html with: self class bodyMapping ] ]
! !

!SFInfo methodsFor: 'rendering' stamp: 'NickAger 7/30/2010 15:52'!
renderTagsAndSelectorsOn: html with: tagsSelectorsAttributes
	tagsSelectorsAttributes do: [ :association | 
		| deprecatedAttributes |
		html div class: 'body'; with: [ 
			| htmlTag lookup selector |
			htmlTag := association key.
			lookup := association value.
			selector := lookup at: #selector.
			
			html div class: 'htmlTag'; with: htmlTag.
			html div class: 'factorySelector'; with: selector.
			html div class: 'allAttributes'; with:[
				html div class: 'attributes'; with: [ 
				self renderAttributes: (lookup at: #attributeMapping) on: html title: 'Attributes for ''', selector greaseString,''''.
				
				deprecatedAttributes := lookup at: #attributeMappingDeprecated.
				deprecatedAttributes size ~= 0 ifTrue: [
					| sortedDeprecatedAttributes |
					sortedDeprecatedAttributes := deprecatedAttributes associations asSortedCollection.
					html space.

					html anchor
						class: 'deprecatedAttributes';
						onClick: (self renderAttributesDialogOn: html attributes:  sortedDeprecatedAttributes title: 'Deprecated attributes for ''', selector greaseString,'''');
						url: 'javascript:void(0)';
						with: '[deprecated attributes...]' ] ] ] ] ]! !

!SFInfo methodsFor: 'rendering' stamp: 'NickAger 7/29/2010 22:29'!
updateRoot: anHtmlRoot
	anHtmlRoot stylesheet url: SFLibrary / #infoCss
! !
SFInfo initialize!
